untyped
global function cl_centerdot_init
global function ui_centerdot_init

void function cl_centerdot_init()
{
	#if CLIENT
	if ( !IsLobby() )
		thread centerdot_main()
	#endif
}

#if CLIENT
array< asset > crosshair_assets =
[
	$"ui/crosshair_tri.rpak",             $"ui/crosshair_alternator.rpak",    $"ui/crosshair_shotgun.rpak", 
	$"ui/crosshair_mastiff.rpak",         $"ui/crosshair_wingman_n.rpak",     $"ui/crosshair_grenade_launcher.rpak", 
	$"ui/crosshair_mozambique.rpak",      $"ui/crosshair_smr.rpak",           $"ui/crosshair_wingman.rpak", 
	$"ui/crosshair_circle2.rpak",         $"ui/crosshair_circle2_small.rpak", $"ui/crosshair_charge_rifle.rpak", 
	$"ui/crosshair_plus.rpak",            $"ui/crosshair_leadwall.rpak",      $"ui/crosshair_flight_core.rpak", 
	$"ui/crosshair_titan_sniper.rpak",    $"ui/crosshair_40mm.rpak",          $"ui/crosshair_scorch.rpak", 
	$"ui/crosshair_tracker_rockets.rpak", $"ui/crosshair_frag.rpak",          $"ui/crosshair_arc.rpak", 
	$"ui/crosshair_pulse_blade.rpak",     $"ui/crosshair_gravstar.rpak",      $"ui/crosshair_satchel.rpak", 
	$"ui/crosshair_firestar.rpak",        $"ui/crosshair_esmoke.rpak",        $"ui/crosshair_sniper_amped.rpak"
]
void function centerdot_main()
{
	var dot = RuiCreate( $"ui/crosshair_wingman_n.rpak", clGlobal.topoFullScreen, RUI_DRAW_HUD, 1 )
	
	do
	{
		WaitFrame()
		
		if ( !GetConVarBool( "mm_centerdot_enabled" ) ) // if disabled, fade it fully out using adsfrac
			RuiSetFloat( dot, "adsFrac", 1 )
		else
			RuiSetFloat( dot, "adsFrac", 0 )
		
		RuiSetFloat3( dot, "teamColor", GetConVarFloat3( "mm_centerdot_color" ) )
		
	} while ( IsValid( GetLocalClientPlayer() ) )
	
	RuiDestroyIfAlive( dot )
}

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}
#endif

void function ui_centerdot_init()
{
	#if UI
	array<string> crosshair_names = 
	[
	"Car",         "Alternator",  "EVA", 
	"Mastiff",     "WingmanE",    "GL", 
	"Mozambique",  "SMR",         "B3wingman", 
	"CircleBig",   "CircleSmall", "ChargeRifle", 
	"Plus",        "Leadwall",    "FlightCore", 
	"TitanSniper", "40mm",        "Scorch", 
	"Rockets",     "Frag",        "Arc", 
	"PulseBlade",  "GravStar",    "Satchel", 
	"Firestar",    "eSmoke",      "Empty"
	]
    ModSettings_AddModTitle		( "mm.StaticCrosshair" )
    ModSettings_AddModCategory	( "Crosshair" )
    ModSettings_AddSetting		( "mm_centerdot_color",   "Color",   "vector" )
    ModSettings_AddEnumSetting	( "mm_centerdot_enabled", "Enabled", ["Off", "On"] )
    //AddConVarSettingEnum		( "mm_centerdot_type", "Crosshair Shape", crosshair_names )
	printt("kys")
	#endif
}